diff --git a/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java b/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
index c49bd0eda..173e5796d 100644
--- a/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
+++ b/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
@@ -9,9 +9,9 @@ import com.google.gson.JsonParseException;
 import com.google.gson.JsonParser;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.data.registry.Registry;
+import net.minecraft.core.lang.I18n;
 
 import java.io.File;
-import java.io.IOException;
 import java.io.InputStream;
 import java.nio.file.Files;
 import java.util.ArrayList;
@@ -61,6 +61,9 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
                     }
                 }
             }
+            if (e.getValue().subtitleKey != null) {
+                I18n.getInstance().translateKey(e.getValue().subtitleKey);
+            }
         }
 
         thrown.forEach(Throwable::printStackTrace);
@@ -101,7 +104,7 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
 
             SoundEvent soundEvent = eventMap.get(fieldName);
             if (soundEvent == null || replaceEvent) {
-                soundEvent = new SoundEvent(fieldName, subtitle);
+                soundEvent = new SoundEvent(this,fieldName, subtitle);
             }
             if (subtitle != null) {
                 soundEvent.subtitleKey = subtitle;
@@ -122,13 +125,13 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
                     for (JsonElement element : sounds) {
                         if (element.isJsonPrimitive()) {
                             try {
-                                soundEvent.addSoundEntry(getSoundEntry(pack, element.getAsString()));
+                                soundEvent.addSoundEntry(getSoundEntry(soundEvent, pack, element.getAsString()));
                             } catch (RuntimeException ex) {
                                 throwableList.add(ex);
                             }
                         } else if (element.isJsonObject()) {
                             try {
-                                soundEvent.addSoundEntry(getSoundEntry(pack, element.getAsJsonObject()));
+                                soundEvent.addSoundEntry(getSoundEntry(soundEvent, pack, element.getAsJsonObject()));
                             } catch (RuntimeException ex) {
                                 throwableList.add(ex);
                             }
@@ -140,11 +143,22 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
         }
     }
 
-    public SoundEntry getSoundEntry(TexturePack pack, String path) {
-        return new SoundEntry(this, pack,path, 1, false, SoundEntry.Type.FILE);
+    public SoundEntry getSoundEntry(SoundEvent event, TexturePack pack, String path) {
+        return new SoundEntry
+            (
+                event,
+                pack,
+                path,
+                1f,
+                1f,
+                1,
+                16,
+                false,
+                SoundEntry.Type.FILE
+            );
     }
 
-    public SoundEntry getSoundEntry(TexturePack pack, JsonObject jObj) throws JsonParseException {
+    public SoundEntry getSoundEntry(SoundEvent event, TexturePack pack, JsonObject jObj) throws JsonParseException {
         String name = jObj.get("name").getAsString(); // Required
 
         float volume = 1;
@@ -182,7 +196,18 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
             type = jObj.get("type").getAsString();
         }
 
-        return new SoundEntry(this, pack, name, weight, stream, SoundEntry.Type.valueOf(type.toUpperCase(Locale.ROOT)));
+        return new SoundEntry
+            (
+                event,
+                pack,
+                name,
+                volume,
+                pitch,
+                weight,
+                attenuation_distance,
+                stream,
+                SoundEntry.Type.valueOf(type.toUpperCase(Locale.ROOT)
+                ));
     }
 
     private JsonElement loadStreamAsElement(InputStream stream) throws JsonParseException {
diff --git a/src/main/java/net/minecraft/client/sound/SoundCategoryHelper.java b/src/main/java/net/minecraft/client/sound/SoundCategoryHelper.java
index 9c710092d..73fa45e5a 100644
--- a/src/main/java/net/minecraft/client/sound/SoundCategoryHelper.java
+++ b/src/main/java/net/minecraft/client/sound/SoundCategoryHelper.java
@@ -1,14 +1,17 @@
 package net.minecraft.client.sound;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.VolumeOption;
 import net.minecraft.core.sound.SoundCategory;
+import org.slf4j.Logger;
 
 import java.lang.reflect.Field;
 import java.util.HashMap;
 
 public class SoundCategoryHelper
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final HashMap<SoundCategory, Field> VOLUME_FIELDS = new HashMap<>();
 
     static
@@ -52,7 +55,7 @@ public class SoundCategoryHelper
         }
         catch (Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Failed to get volume for category '{}'!", field.getName(), e);
             return 0.0f;
         }
     }
@@ -69,7 +72,7 @@ public class SoundCategoryHelper
         }
         catch (Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Failed to get effective volume for category '{}'!", field.getName(), e);
             return 0.0f;
         }
     }
@@ -86,7 +89,7 @@ public class SoundCategoryHelper
         }
         catch (Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Failed to set volume for category '{}'!", field.getName(), e);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/sound/SoundEngine.java b/src/main/java/net/minecraft/client/sound/SoundEngine.java
index 39640ef00..41ff4cf9c 100644
--- a/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -3,12 +3,14 @@ package net.minecraft.client.sound;
 import java.net.URL;
 import java.util.Random;
 
+import com.mojang.logging.LogUtils;
 import net.betterthanadventure.sound.LibraryLWJGL3OpenAL;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.client.option.GameSettings;
+import org.slf4j.Logger;
 import paulscode.sound.SoundSystem;
 import paulscode.sound.SoundSystemConfig;
 import paulscode.sound.codecs.CodecJOrbis;
@@ -16,8 +18,8 @@ import paulscode.sound.codecs.CodecWav;
 
 public class SoundEngine
 {
-	private static final int SOUND_DISTANCE = 16; // TODO have the sound engine handle sound distance again
-	private static final int MUSIC_INTERVAL = 6000;
+	private static final Logger LOGGER = LogUtils.getLogger();
+  private static final int MUSIC_INTERVAL = 6000;
 	private static SoundSystem soundSystem;
 	private static boolean loaded = false;
 
@@ -48,9 +50,9 @@ public class SoundEngine
 		if (soundSystem == null) return;
 		this.muted = muted;
 		if (this.muted) {
-			soundSystem.setVolume("BgMusic", 0.0f);
+			soundSystem.setVolume(BG_MUSIC, 0.0f);
 		} else {
-			soundSystem.setVolume("BgMusic", SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options));
+			soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options));
 		}
 	}
 
@@ -112,7 +114,7 @@ public class SoundEngine
 			// TODO a more sane way of grouping music pools with our new system
 			SoundEvent event;
             if (mc != null && mc.thePlayer != null && !mc.thePlayer.world.canBlockSeeTheSky(MathHelper.floor(mc.thePlayer.x), MathHelper.floor(mc.thePlayer.y), MathHelper.floor(mc.thePlayer.z))) {
-				event = SoundRepository.SOUNDS.getRandomSoundFromCategory("ambient.cave.");
+				event = SoundRepository.SOUNDS.getSoundEvent("ambient.cave");
             } else {
 				event = SoundRepository.SOUNDS.getRandomSoundFromCategory("music.");
             }
@@ -120,9 +122,10 @@ public class SoundEngine
 			SoundEntry entry = event.getRandomEntry();
             if (entry != null) {
                 ticksBeforeMusic = random.nextInt(MUSIC_INTERVAL) + MUSIC_INTERVAL;
-                soundSystem.backgroundMusic("BgMusic", entry.getURL(), entry.name, false);
-                soundSystem.setVolume("BgMusic", SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options));
-                soundSystem.play("BgMusic");
+                soundSystem.backgroundMusic(BG_MUSIC, entry.getURL(), entry.name, false);
+				soundSystem.setPitch(BG_MUSIC, entry.pitch);
+                soundSystem.setVolume(BG_MUSIC, SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options) * entry.volume);
+                soundSystem.play(BG_MUSIC);
             }
         }
     }
@@ -178,12 +181,15 @@ public class SoundEngine
 						volume = 1.0F;
 					}
 					volume *= 0.25F;
-					soundSystem.setPitch(soundID, pitch);
-					soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, options));
+					soundSystem.setPitch(soundID, pitch * entry.pitch);
+					soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, options) * entry.volume);
 					soundSystem.play(soundID);
 				}
+				if (entry.parent.hasSubtitle()) {
+					mc.subtitleTracker.heardSound(entry.parent, 0, 0, 0);
+				}
 			} else if (entry.type == SoundEntry.Type.EVENT) {
-				playSoundWithIdAtPos(entry.name, category, 0, 0, 0, volume, pitch, soundID);
+				playSoundWithID(entry.name, category, volume, pitch, soundID);
 			}
 		}
 	}
@@ -194,26 +200,32 @@ public class SoundEngine
 
 	public void playSoundWithIdAtPos(SoundEntry entry, SoundCategory category, float x, float y, float z, float volume, final float pitch, String soundID) {
 		if (entry != null) {
+			float soundDistance = entry.attenuationDistance;
+			if(volume > 1.0F)
+			{
+				soundDistance *= volume;
+			}
+			if(mc.activeCamera.distanceToSqr(x, y, z) > (double)(soundDistance * soundDistance)) return;
+
 			if (entry.type == SoundEntry.Type.FILE) {
 				URL url = entry.getURL();
 				if (url != null){
-					float f5 = 16F;
-					if (volume > 1.0F)
-					{
-						f5 *= volume;
-					}
 					if (entry.shouldStream) {
-						soundSystem.newStreamingSource(volume > 1.0F, soundID, url, entry.name, false, x, y, z, 2, f5);
+						soundSystem.newStreamingSource(volume > 1.0F, soundID, url, entry.name, false, x, y, z, 2, soundDistance);
 					} else {
-						soundSystem.newSource(volume > 1.0F, soundID, url, entry.name, false, x, y, z, 0, f5);
+						soundSystem.newSource(volume > 1.0F, soundID, url, entry.name, false, x, y, z, 2, soundDistance);
 					}
 					if (volume > 1.0F) {
 						volume = 1.0F;
 					}
-					soundSystem.setPitch(soundID, pitch);
-					soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, options));
+
+					soundSystem.setPitch(soundID, pitch * entry.pitch);
+					soundSystem.setVolume(soundID, volume * SoundCategoryHelper.getEffectiveVolume(category, options) * entry.volume);
 					soundSystem.play(soundID);
 				}
+				if (entry.parent.hasSubtitle()) {
+					mc.subtitleTracker.heardSound(entry.parent, x, y, z);
+				}
 			} else if (entry.type == SoundEntry.Type.EVENT) {
 				playSoundWithIdAtPos(entry.name, category, x, y, z, volume, pitch, soundID);
 			}
@@ -230,7 +242,6 @@ public class SoundEngine
 		{
 			return;
 		}
-		final String streaming = STREAMING;
 		if (soundSystem.playing(STREAMING))
 		{
 			soundSystem.stop(STREAMING);
@@ -245,13 +256,13 @@ public class SoundEngine
 			{
 				soundSystem.stop(BG_MUSIC);
 			}
-			final float streamingVolume = 16F;
 			if (entry.type == SoundEntry.Type.FILE) {
 				URL url = entry.getURL();
 				if (url != null) {
-					soundSystem.newStreamingSource(true, streaming, url, entry.name, false, x, y, z, 2, streamingVolume * 4F);
-					soundSystem.setVolume(streaming, 0.5F * options.masterVolume.value);
-					soundSystem.play(streaming);
+					soundSystem.newStreamingSource(true, STREAMING, url, entry.name, false, x, y, z, 2, entry.attenuationDistance);
+					soundSystem.setPitch(STREAMING, pitch * entry.pitch);
+					soundSystem.setVolume(STREAMING, volume * entry.volume * options.masterVolume.value);
+					soundSystem.play(STREAMING);
 				}
 			} else if (entry.type == SoundEntry.Type.EVENT) {
 				playMusic(entry.name, x, y, z, volume, pitch);
@@ -283,8 +294,7 @@ public class SoundEngine
 			}
 			options.saveOptions();
         } catch (final Throwable throwable) {
-            throwable.printStackTrace();
-            System.err.println("error linking with the LibraryJavaSound plug-in");
+			LOGGER.error("Error linking with the LibraryJavaSound plug-in", throwable);
         }
         loaded = true;
     }
diff --git a/src/main/java/net/minecraft/client/sound/SoundEntry.java b/src/main/java/net/minecraft/client/sound/SoundEntry.java
index c08925db0..ddf1aca97 100644
--- a/src/main/java/net/minecraft/client/sound/SoundEntry.java
+++ b/src/main/java/net/minecraft/client/sound/SoundEntry.java
@@ -9,7 +9,7 @@ import java.net.MalformedURLException;
 import java.net.URL;
 
 public class SoundEntry {
-    public final @NotNull NamedSoundRepository parent;
+    public final @NotNull SoundEvent parent;
     public final @NotNull TexturePack pack;
 
     public final @NotNull String name;
@@ -19,6 +19,21 @@ public class SoundEntry {
      */
     public final int weight;
 
+    /**
+     * Distance the sound can be heard
+     */
+    public final int attenuationDistance;
+
+    /**
+     * Volume to play the sound with
+     */
+    public final float volume;
+
+    /**
+     * Pitch to play the sound with
+     */
+    public final float pitch;
+
     /**
      *  Whether the audio should be played as a stream or not
      */
@@ -31,15 +46,29 @@ public class SoundEntry {
 
     protected @Nullable File file;
 
-    public SoundEntry(@NotNull NamedSoundRepository parent, @NotNull TexturePack pack, @NotNull String name, int weight, boolean shouldStream, @NotNull Type type) {
-        this.parent = parent;
+    public SoundEntry
+        (
+        @NotNull SoundEvent parentEvent, @NotNull TexturePack pack,
+        @NotNull String name,
+        float volume,
+        float pitch,
+        int weight,
+        int attenuationDistance,
+        boolean shouldStream,
+        @NotNull Type type
+    )
+    {
+        this.parent = parentEvent;
         this.pack = pack;
         this.name = name;
+        this.volume = volume;
+        this.pitch = pitch;
         this.weight = weight;
+        this.attenuationDistance = attenuationDistance;
         this.shouldStream = shouldStream;
         this.type = type;
         if (type == Type.FILE) {
-            file = new File(parent.rootFile, name);
+            file = new File(parentEvent.parentRepo.rootFile, name);
         } else {
             file = null;
         }
diff --git a/src/main/java/net/minecraft/client/sound/SoundEvent.java b/src/main/java/net/minecraft/client/sound/SoundEvent.java
index 5cd95112f..de56f08ca 100644
--- a/src/main/java/net/minecraft/client/sound/SoundEvent.java
+++ b/src/main/java/net/minecraft/client/sound/SoundEvent.java
@@ -10,9 +10,11 @@ import java.util.Random;
 public class SoundEvent {
     private final WeightedRandomBag<SoundEntry> entryBag = new WeightedRandomBag<>();
 
+    public final @NotNull NamedSoundRepository parentRepo;
     private final @NotNull String id;
     protected @Nullable String subtitleKey;
-    public SoundEvent(@NotNull String eventID, @Nullable String subtitleKey) {
+    public SoundEvent(@NotNull NamedSoundRepository parentRepo, @NotNull String eventID, @Nullable String subtitleKey) {
+        this.parentRepo = parentRepo;
         this.id = eventID;
         this.subtitleKey = subtitleKey;
     }
diff --git a/src/main/java/net/minecraft/client/util/debug/Debug.java b/src/main/java/net/minecraft/client/util/debug/Debug.java
index 30d5acd52..7afeeaf8f 100644
--- a/src/main/java/net/minecraft/client/util/debug/Debug.java
+++ b/src/main/java/net/minecraft/client/util/debug/Debug.java
@@ -1,12 +1,15 @@
 package net.minecraft.client.util.debug;
 
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
+
 import java.util.ArrayList;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
 public class Debug {
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public static boolean enable = true;
 	
 	static final Profiler baseProfiler = new Profiler("base", null);
@@ -31,7 +34,7 @@ public class Debug {
 	
 	public static void reset() {
 		if(currentProfiler != baseProfiler) {
-			System.out.println("Invalid profiler state: " +(currentProfiler != null ? currentProfiler.name : null));
+            LOGGER.warn("Invalid profiler state: {}", currentProfiler != null ? currentProfiler.name : null);
 			currentProfiler = baseProfiler;
 		}
 		reset(currentProfiler);
diff --git a/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index 999f6a95c..05bdbb1ba 100644
--- a/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -6,7 +6,7 @@ import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.Display;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.debug.Debug.Profiler;
 import net.minecraft.core.util.helper.MathHelper;
@@ -64,7 +64,7 @@ public class DebugRender {
 		resetFrametimes();
 	}
 	
-	public static void render(FontRenderer fontRenderer) {
+	public static void render(Font font) {
 		frametimes[pos] = selectedProfiler.time;
 		baseframetimes[pos] = Debug.baseProfiler.time;
 		pos++;
@@ -117,10 +117,10 @@ public class DebugRender {
 		
 		int fps = Debug.getFps();
 		if(fps >= 0) {
-			fontRenderer.drawString("fps: " + fps, x1, y1 - 2 * lineHeight, 0xFFFFFFFF);
+			font.drawString("fps: " + fps, x1, y1 - 2 * lineHeight, 0xFFFFFFFF);
 		}
-		fontRenderer.drawString("avg: " + (getAvgTime(frametimes) / 1000.0) + " ms", x1, y1 - lineHeight, 0xFFFFFFFF);
-		fontRenderer.drawString(selectedProfiler.name + ": ", x1, y1, 0xFFFFFFFF);
+		font.drawString("avg: " + (getAvgTime(frametimes) / 1000.0) + " ms", x1, y1 - lineHeight, 0xFFFFFFFF);
+		font.drawString(selectedProfiler.name + ": ", x1, y1, 0xFFFFFFFF);
 		for(int i=0; i < selectedProfiler.allProfilers.size(); i++) {
 			Profiler profiler = selectedProfiler.allProfilers.get(i);
 
@@ -128,7 +128,7 @@ public class DebugRender {
 			if(i == selection) {
 				color = 0xFF00FFFF;
 			}
-			fontRenderer.drawString(i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight, color);
+			font.drawString(i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight, color);
 		}
 		glEnable(GL_ALPHA_TEST);
 	}
diff --git a/src/main/java/net/minecraft/client/util/helper/GuiItemDragHandler.java b/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
similarity index 94%
rename from src/main/java/net/minecraft/client/util/helper/GuiItemDragHandler.java
rename to src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index 4f2d26f4c..a179ad506 100644
--- a/src/main/java/net/minecraft/client/util/helper/GuiItemDragHandler.java
+++ b/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -11,17 +11,17 @@ import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiContainer;
-import net.minecraft.client.gui.GuiRenderItem;
+import net.minecraft.client.gui.container.AbstractContainerScreen;
+import net.minecraft.client.gui.ItemElement;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-public class GuiItemDragHandler extends Gui {
+public class ItemDragHandler extends Gui {
 	
 	public final Minecraft mc;
-	public final GuiContainer container;
-	public final GuiRenderItem guiRenderItem;
+	public final AbstractContainerScreen container;
+	public final ItemElement itemElement;
 	
 	private int renderOffsetX;
 	private int renderOffsetY;
@@ -45,10 +45,10 @@ public class GuiItemDragHandler extends Gui {
 	private boolean lastClickHoldingItem = false;
 	private boolean doubleClick = false;
 	
-	public GuiItemDragHandler(Minecraft minecraft, GuiContainer container, GuiRenderItem renderItem) {
+	public ItemDragHandler(Minecraft minecraft, AbstractContainerScreen screen, ItemElement itemElement) {
 		this.mc = minecraft;
-		this.container = container;
-		this.guiRenderItem = renderItem;
+		this.container = screen;
+		this.itemElement = itemElement;
 	}
 	
 	public void drawScreen(int mouseX, int mouseY, float partialTicks) {
@@ -123,7 +123,7 @@ public class GuiItemDragHandler extends Gui {
 		if(stack != null) {
 			renderItemStack.stackSize = Math.min(renderItemStack.getMaxStackSize(), renderItemStack.stackSize + stack.stackSize);
 		}
-		guiRenderItem.render(renderItemStack, slot.x, slot.y);
+		itemElement.render(renderItemStack, slot.x, slot.y);
 	}
 	
 	public void mouseEvent(final int x, final int y, int button, boolean pressed) {
diff --git a/src/main/java/net/minecraft/client/util/helper/Textures.java b/src/main/java/net/minecraft/client/util/helper/Textures.java
index 923ae46fe..9de2b4a8d 100644
--- a/src/main/java/net/minecraft/client/util/helper/Textures.java
+++ b/src/main/java/net/minecraft/client/util/helper/Textures.java
@@ -16,6 +16,7 @@ import java.util.List;
 
 import javax.imageio.ImageIO;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.util.helper.Buffer;
 import org.lwjgl.opengl.GL12;
 
@@ -23,9 +24,10 @@ import com.b100.utils.ImageUtils;
 
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.render.OpenGLHelper;
+import org.slf4j.Logger;
 
 public class Textures {
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public static BufferedImage missingTexture;
 	
 	static {
@@ -107,25 +109,27 @@ public class Textures {
 		File folder = new File("dumpTextures");
 		if(folder.exists()) {
 			File[] files = folder.listFiles();
-			for(int i=0; i < files.length; i++) {
-				files[i].delete();
+			if (files != null) {
+				for (File file : files) {
+					file.delete();
+				}
 			}
 		}
 		
 		OpenGLHelper.checkError("pre texture dump");
-		
-		System.out.println("Dump Textures...");
+
+		LOGGER.info("Dump Textures...");
 		
 		List<Integer> textureList = GLAllocation.textureNames;
 		for(int i=0; i < textureList.size(); i++) {
 			Integer tex = textureList.get(i);
-			
-			System.out.println("Tex: " + tex);
+
+            LOGGER.debug("Tex: {}", tex);
 			
 			glBindTexture(GL_TEXTURE_2D, tex);
 			int maxLevel = glGetTexParameteri(GL_TEXTURE_2D, GL12.GL_TEXTURE_MAX_LEVEL);
-			
-			System.out.println("Max Level: " + maxLevel);
+
+            LOGGER.debug("Max Level: {}", maxLevel);
 			
 			for(int level = 0; level <= maxLevel; level++) {
 				int w = glGetTexLevelParameteri(GL_TEXTURE_2D, level, GL_TEXTURE_WIDTH);
@@ -136,8 +140,8 @@ public class Textures {
 				if(w == 0 || h == 0) {
 					break;
 				}
-				
-				System.out.println("Level " + level + ": " + w + " x " + h);
+
+                LOGGER.debug("Level {}: {} x {}", level, w, h);
 				
 				int size = w * h * 4;
 				Buffer.checkBufferSize(size);
@@ -153,12 +157,12 @@ public class Textures {
 					ImageUtils.saveExternalImage(getImage(buffer, w, h, false, false), new File(folder, "tex"+tex+"-level"+level+"-opaque.png"));
 
 				}else {
-					System.out.println("Cannot get pixel data");
+					LOGGER.warn("Cannot get pixel data");
 				}
 			}
 		}
-		
-		System.out.println("Dumped textures into " + folder.getAbsolutePath());
+
+        LOGGER.info("Dumped textures into {}", folder.getAbsolutePath());
 		OpenGLHelper.checkError("texture dump");
 	}
 	
@@ -168,7 +172,7 @@ public class Textures {
 			file.createNewFile();
 			ImageIO.write(image, "png", file);
 		}catch (Exception e) {
-			e.printStackTrace();
+            LOGGER.error("Failed to save image to file '{}'!", file.getPath(), e);
 		}
 	}
 	
@@ -182,8 +186,8 @@ public class Textures {
 		int h = glGetTexLevelParameteri(GL_TEXTURE_2D, level, GL_TEXTURE_HEIGHT);
 		
 		if(w == 0 || h == 0) return null;
-		
-		System.out.println("Texture "+texture+" Size: "+w+" x "+h);
+
+        LOGGER.debug("Texture {} Size: {} x {}", texture, w, h);
 		
 		Buffer.reset();
 		Buffer.checkBufferSize(w * h * 16);
diff --git a/src/main/java/net/minecraft/client/world/WorldClient.java b/src/main/java/net/minecraft/client/world/WorldClient.java
index 8b8c932a3..a3d361827 100644
--- a/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -69,6 +69,10 @@ public class WorldClient extends World {
             }
         }
 		updateSeasonAndLight();
+        if(rainbowTicks > 0)
+        {
+            rainbowTicks--;
+        }
     }
 
     public void processPackets() {
@@ -201,13 +205,13 @@ public class WorldClient extends World {
     }
 
     @Override
-	public boolean setBlockMetadata(int i, int j, int k, int l)
+	public boolean setBlockMetadata(int x, int y, int z, int meta)
     {
-        int i1 = getBlockId(i, j, k);
-        int j1 = getBlockMetadata(i, j, k);
-        if(super.setBlockMetadata(i, j, k, l))
+        int blockID = getBlockId(x, y, z);
+        int currentMeta = getBlockMetadata(x, y, z);
+        if(super.setBlockMetadata(x, y, z, meta))
         {
-            positionTypesList.add(new WorldBlockPositionType(this, i, j, k, i1, j1));
+            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockID, currentMeta));
             return true;
         } else
         {
@@ -216,13 +220,13 @@ public class WorldClient extends World {
     }
 
     @Override
-	public boolean setBlockAndMetadata(int i, int j, int k, int l, int i1)
+	public boolean setBlockAndMetadata(int x, int y, int z, int id, int meta)
     {
-        int j1 = getBlockId(i, j, k);
-        int k1 = getBlockMetadata(i, j, k);
-        if(super.setBlockAndMetadata(i, j, k, l, i1))
+        int blockId = getBlockId(x, y, z);
+        int blockMeta = getBlockMetadata(x, y, z);
+        if(super.setBlockAndMetadata(x, y, z, id, meta))
         {
-            positionTypesList.add(new WorldBlockPositionType(this, i, j, k, j1, k1));
+            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockId, blockMeta));
             return true;
         } else
         {
@@ -237,7 +241,7 @@ public class WorldClient extends World {
         int meta = getBlockMetadata(x, y, z);
         if(super.setBlock(x, y, z, id))
         {
-            positionTypesList.add(new WorldBlockPositionType(this, x, y, z, blockId, meta));
+            positionTypesList.add(new WorldBlockPositionType(x, y, z, blockId, meta));
             return true;
         } else
         {
@@ -268,4 +272,23 @@ public class WorldClient extends World {
     public void sendGlobalMessage(String message){
 
     }
+
+    static class WorldBlockPositionType
+    {
+        int x;
+        int y;
+        int z;
+        int delayTicks;
+        int blockId;
+        int metadata;
+
+        public WorldBlockPositionType(int x, int y, int z, int blockId, int metadata) {
+            this.x = x;
+            this.y = y;
+            this.z = z;
+            this.delayTicks = 80;
+            this.blockId = blockId;
+            this.metadata = metadata;
+        }
+    }
 }
